'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_ioc_1 = require("typescript-ioc");
const typescript_rest_1 = require("typescript-rest");
const swagger = require("typescript-rest-swagger");
const api_1 = require("../../config/api");
const configuration_1 = require("../../configuration");
const api_2 = require("../../service/api");
let APIRest = class APIRest {
    list(name, version, description, path) {
        return this.service.list(name, version, description, path);
    }
    async addApi(api) {
        await api_1.validateApiConfig(api, this.config.gateway.disableApiIdValidation);
        const apiId = await this.service.create(api);
        return (new typescript_rest_1.Return.NewResource(`apis/${apiId}`));
    }
    async updateApi(id, api) {
        api.id = id;
        await api_1.validateApiConfig(api, this.config.gateway.disableApiIdValidation);
        await this.service.update(api);
    }
    async removeApi(id) {
        await this.service.remove(id);
    }
    async getApi(id) {
        return await this.service.get(id);
    }
};
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", api_2.ApiService)
], APIRest.prototype, "service", void 0);
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", configuration_1.Configuration)
], APIRest.prototype, "config", void 0);
__decorate([
    typescript_rest_1.GET,
    __param(0, typescript_rest_1.QueryParam('name')),
    __param(1, typescript_rest_1.QueryParam('version')),
    __param(2, typescript_rest_1.QueryParam('description')),
    __param(3, typescript_rest_1.QueryParam('path')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String, String]),
    __metadata("design:returntype", Promise)
], APIRest.prototype, "list", null);
__decorate([
    typescript_rest_1.POST,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], APIRest.prototype, "addApi", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('/:id'),
    __param(0, typescript_rest_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], APIRest.prototype, "updateApi", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('/:id'),
    __param(0, typescript_rest_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], APIRest.prototype, "removeApi", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('/:id'),
    __param(0, typescript_rest_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], APIRest.prototype, "getApi", null);
APIRest = __decorate([
    typescript_rest_1.Path('apis'),
    swagger.Tags('APIs'),
    swagger.Security('Bearer')
], APIRest);
exports.APIRest = APIRest;
//# sourceMappingURL=api.js.map