'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const typescript_ioc_1 = require("typescript-ioc");
const typescript_rest_1 = require("typescript-rest");
const swagger = require("typescript-rest-swagger");
const middleware_1 = require("../../service/middleware");
let MiddlewareRest = class MiddlewareRest {
    filters(name) {
        return this.service.list('filter', name);
    }
    requestInterceptors(name) {
        return this.service.list('interceptor/request', name);
    }
    responseInterceptors(name) {
        return this.service.list('interceptor/response', name);
    }
    authStrategies(name) {
        return this.service.list('authentication/strategy', name);
    }
    authVerify(name) {
        return this.service.list('authentication/verify', name);
    }
    throttlingKeyGenerator(name) {
        return this.service.list('throttling/keyGenerator', name);
    }
    throttlingHandler(name) {
        return this.service.list('throttling/handler', name);
    }
    throttlingSkip(name) {
        return this.service.list('throttling/skip', name);
    }
    circuitBreaker(name) {
        return this.service.list('circuitbreaker', name);
    }
    corsOrigin(name) {
        return this.service.list('cors/origin', name);
    }
    proxyRouter(name) {
        return this.service.list('proxy/router', name);
    }
    serviceDiscovery(name) {
        return this.service.list('servicediscovery', name);
    }
    serviceDiscoveryProvider(name) {
        return this.service.list('servicediscovery/provider', name);
    }
    errorHandler(name) {
        return this.service.list('errorhandler', name);
    }
    requestLogger(name) {
        return this.service.list('request/logger', name);
    }
    removeFilter(name) {
        return this.service.remove('filter', name);
    }
    removeRequestInterceptor(name) {
        return this.service.remove('interceptor/request', name);
    }
    removeResponseInterceptor(name) {
        return this.service.remove('interceptor/response', name);
    }
    removeAuthStrategy(name) {
        return this.service.remove('authentication/strategy', name);
    }
    removeAuthVerify(name) {
        return this.service.remove('authentication/verify', name);
    }
    removeThrottlingKeyGenerator(name) {
        return this.service.remove('throttling/keyGenerator', name);
    }
    removeThrottlingHandler(name) {
        return this.service.remove('throttling/handler', name);
    }
    removeThrottlingSkip(name) {
        return this.service.remove('throttling/skip', name);
    }
    removeCircuitBreaker(name) {
        return this.service.remove('circuitbreaker', name);
    }
    removeCors(name) {
        return this.service.remove('cors/origin', name);
    }
    removeProxyRouter(name) {
        return this.service.remove('proxy/router', name);
    }
    removeServiceDiscovery(name) {
        return this.service.remove('servicediscovery', name);
    }
    removeServiceDiscoveryProvider(name) {
        return this.service.remove('servicediscovery/provider', name);
    }
    removeErrorHandler(name) {
        return this.service.remove('errorhandler', name);
    }
    removeRequestLogger(name) {
        return this.service.remove('request/logger', name);
    }
    updateFilter(name, file) {
        return this.saveMiddleware('filter', file, name);
    }
    updateRequestInterceptor(name, file) {
        return this.saveMiddleware('interceptor/request', file, name);
    }
    updateResponseInterceptor(name, file) {
        return this.saveMiddleware('interceptor/response', file, name);
    }
    updateAuthStrategy(name, file) {
        return this.saveMiddleware('authentication/strategy', file, name);
    }
    updateAuthVerify(name, file) {
        return this.saveMiddleware('authentication/verify', file, name);
    }
    updateThrottlingKeyGenerator(name, file) {
        return this.saveMiddleware('throttling/keyGenerator', file, name);
    }
    updateThrottlingHandler(name, file) {
        return this.saveMiddleware('throttling/handler', file, name);
    }
    updateThrottlingSkip(name, file) {
        return this.saveMiddleware('throttling/skip', file, name);
    }
    updateCircuitBreaker(name, file) {
        return this.saveMiddleware('circuitbreaker', file, name);
    }
    updateCors(name, file) {
        return this.saveMiddleware('cors/origin', file, name);
    }
    updateProxyRouter(name, file) {
        return this.saveMiddleware('proxy/router', file, name);
    }
    updateServiceDiscovery(name, file) {
        return this.saveMiddleware('servicediscovery', file, name);
    }
    updateServiceDiscoveryProvider(name, file) {
        return this.saveMiddleware('servicediscovery/provider', file, name);
    }
    updateErrorHandler(name, file) {
        return this.saveMiddleware('errorhandler', file, name);
    }
    updateRequestLogger(name, file) {
        return this.saveMiddleware('request/logger', file, name);
    }
    getFilter(name) {
        return this.getMiddleware('filter', name);
    }
    getRequestInterceptor(name) {
        return this.getMiddleware('interceptor/request', name);
    }
    getResponseInterceptor(name) {
        return this.getMiddleware('interceptor/response', name);
    }
    getAuthStrategy(name) {
        return this.getMiddleware('authentication/strategy', name);
    }
    getAuthVerify(name) {
        return this.getMiddleware('authentication/verify', name);
    }
    getThrottlingKeyGenerator(name) {
        return this.getMiddleware('throttling/keyGenerator', name);
    }
    getThrottlingHandler(name) {
        return this.getMiddleware('throttling/handler', name);
    }
    getThrottlingSkip(name) {
        return this.getMiddleware('throttling/skip', name);
    }
    getCircuitBreakerMiddleware(name) {
        return this.getMiddleware('circuitbreaker', name);
    }
    getCorsMiddleware(name) {
        return this.getMiddleware('cors/origin', name);
    }
    getProxyRouterMiddleware(name) {
        return this.getMiddleware('proxy/router', name);
    }
    getServiceDiscoveryMiddleware(name) {
        return this.getMiddleware('servicediscovery', name);
    }
    getServiceDiscoveryProviderMiddleware(name) {
        return this.getMiddleware('servicediscovery/provider', name);
    }
    getErrorHandlerMiddleware(name) {
        return this.getMiddleware('errorhandler', name);
    }
    getRequestLoggerMiddleware(name) {
        return this.getMiddleware('request/logger', name);
    }
    addFilter(file, name) {
        return this.addMiddleware('filter', file, name);
    }
    addRequestInterceptor(file, name) {
        return this.addMiddleware('interceptor/request', file, name, 'interceptors/request');
    }
    addResponseInterceptor(file, name) {
        return this.addMiddleware('interceptor/response', file, name, 'interceptors/response');
    }
    addAuthStrategy(file, name) {
        return this.addMiddleware('authentication/strategy', file, name);
    }
    addAuthVerify(file, name) {
        return this.addMiddleware('authentication/verify', file, name);
    }
    addThrottlingKeyGenerator(file, name) {
        return this.addMiddleware('throttling/keyGenerator', file, name, 'throttling/keyGenerators');
    }
    addThrottlingHander(file, name) {
        return this.addMiddleware('throttling/handler', file, name, 'throttling/handlers');
    }
    addThrottlingSkip(file, name) {
        return this.addMiddleware('throttling/skip', file, name);
    }
    addCircuitBreaker(file, name) {
        return this.addMiddleware('circuitbreaker', file, name);
    }
    addCors(file, name) {
        return this.addMiddleware('cors/origin', file, name);
    }
    addProxyRouter(file, name) {
        return this.addMiddleware('proxy/router', file, name);
    }
    addServiceDiscovery(file, name) {
        return this.addMiddleware('servicediscovery', file, name);
    }
    addServiceDiscoveryProvider(file, name) {
        return this.addMiddleware('servicediscovery/provider', file, name);
    }
    addErrorHandler(file, name) {
        return this.addMiddleware('errorhandler', file, name);
    }
    addRequestLogger(file, name) {
        return this.addMiddleware('request/logger', file, name);
    }
    async getMiddleware(type, name) {
        try {
            const value = await this.service.read(type, name);
            return new typescript_rest_1.Return.DownloadBinaryData(value, 'application/javascript', name + '.js');
        }
        catch (err) {
            throw new typescript_rest_1.Errors.NotFoundError();
        }
    }
    async addMiddleware(type, file, name, basePath) {
        await this.service.add(type, name, file.buffer);
        return new typescript_rest_1.Return.NewResource(path.join(basePath || type, name));
    }
    async saveMiddleware(type, file, name) {
        return await this.service.update(type, name, file.buffer);
    }
};
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", middleware_1.MiddlewareService)
], MiddlewareRest.prototype, "service", void 0);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('filters'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "filters", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('interceptors/request'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "requestInterceptors", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('interceptors/response'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "responseInterceptors", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('authentication/strategies'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "authStrategies", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('authentication/verify'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "authVerify", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/keyGenerators'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "throttlingKeyGenerator", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/handlers'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "throttlingHandler", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/skip'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "throttlingSkip", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('circuitbreaker'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "circuitBreaker", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('cors/origin'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "corsOrigin", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('proxy/router'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "proxyRouter", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('servicediscovery'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "serviceDiscovery", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('servicediscovery/provider'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "serviceDiscoveryProvider", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('errorhandler'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "errorHandler", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('request/logger'),
    __param(0, typescript_rest_1.QueryParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "requestLogger", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('filters/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeFilter", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('interceptors/request/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeRequestInterceptor", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('interceptors/response/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeResponseInterceptor", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('authentication/strategies/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeAuthStrategy", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('authentication/verify/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeAuthVerify", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('throttling/keyGenerators/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeThrottlingKeyGenerator", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('throttling/handlers/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeThrottlingHandler", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('throttling/skip/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeThrottlingSkip", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('circuitbreaker/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeCircuitBreaker", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('cors/origin/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeCors", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('proxy/router/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeProxyRouter", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('servicediscovery/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeServiceDiscovery", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('servicediscovery/provider/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeServiceDiscoveryProvider", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('errorhandler/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeErrorHandler", null);
__decorate([
    typescript_rest_1.DELETE,
    typescript_rest_1.Path('request/logger/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "removeRequestLogger", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('filters/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateFilter", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('interceptors/request/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateRequestInterceptor", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('interceptors/response/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateResponseInterceptor", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('authentication/strategies/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateAuthStrategy", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('authentication/verify/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateAuthVerify", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('throttling/keyGenerators/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateThrottlingKeyGenerator", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('throttling/handlers/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateThrottlingHandler", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('throttling/skip/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateThrottlingSkip", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('circuitbreaker/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateCircuitBreaker", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('cors/origin/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateCors", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('proxy/router/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateProxyRouter", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('servicediscovery/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateServiceDiscovery", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('servicediscovery/provider/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateServiceDiscoveryProvider", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('errorhandler/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateErrorHandler", null);
__decorate([
    typescript_rest_1.PUT,
    typescript_rest_1.Path('request/logger/:name'),
    __param(0, typescript_rest_1.PathParam('name')), __param(1, typescript_rest_1.FileParam('file')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "updateRequestLogger", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('filters/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getFilter", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('interceptors/request/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getRequestInterceptor", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('interceptors/response/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getResponseInterceptor", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('authentication/strategies/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getAuthStrategy", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('authentication/verify/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getAuthVerify", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/keyGenerators/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getThrottlingKeyGenerator", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/handlers/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getThrottlingHandler", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('throttling/skip/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getThrottlingSkip", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('circuitbreaker/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getCircuitBreakerMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('cors/origin/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getCorsMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('proxy/router/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getProxyRouterMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('servicediscovery/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getServiceDiscoveryMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('servicediscovery/provider/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getServiceDiscoveryProviderMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('errorhandler/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getErrorHandlerMiddleware", null);
__decorate([
    typescript_rest_1.GET,
    typescript_rest_1.Path('request/logger/:name'),
    __param(0, typescript_rest_1.PathParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], MiddlewareRest.prototype, "getRequestLoggerMiddleware", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('filters'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addFilter", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('interceptors/request'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addRequestInterceptor", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('interceptors/response'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addResponseInterceptor", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('authentication/strategies'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addAuthStrategy", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('authentication/verify'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addAuthVerify", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('throttling/keyGenerators'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addThrottlingKeyGenerator", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('throttling/handlers'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addThrottlingHander", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('throttling/skip'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addThrottlingSkip", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('circuitbreaker'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addCircuitBreaker", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('cors/origin'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addCors", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('proxy/router'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addProxyRouter", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('servicediscovery'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addServiceDiscovery", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('servicediscovery/provider'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addServiceDiscoveryProvider", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('errorhandler'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addErrorHandler", null);
__decorate([
    typescript_rest_1.POST,
    typescript_rest_1.Path('request/logger'),
    __param(0, typescript_rest_1.FileParam('file')), __param(1, typescript_rest_1.FormParam('name')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], MiddlewareRest.prototype, "addRequestLogger", null);
MiddlewareRest = __decorate([
    typescript_rest_1.Path('middleware'),
    swagger.Tags('Middleware'),
    swagger.Security('Bearer')
], MiddlewareRest);
exports.MiddlewareRest = MiddlewareRest;
//# sourceMappingURL=middleware.js.map