import * as express from 'express';
import { Return } from 'typescript-rest';
import { UserData } from '../../config/users';
export declare class UsersRest {
    static configureAuthMiddleware(app: express.Router): void;
    private service;
    list(): Promise<Array<UserData>>;
    addUser(user: UserData): Promise<Return.NewResource<void>>;
    getUser(login: string): Promise<UserData>;
    updateUser(login: string, user: UserData): Promise<void>;
    removeUser(login: string): Promise<void>;
    getAuthToken(login: string, password: string): Promise<string>;
    changePassword(req: express.Request, login: string, password: string): Promise<void>;
}
