'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
class GatewayClient {
    constructor(swaggerClient) {
        this.swaggerClient = swaggerClient;
    }
    async updateConfig(config) {
        const response = await utils_1.invoke(this.swaggerClient.apis.Gateway.GatewayRestUpdateConfig({ config: config }));
        utils_1.checkStatus(response, 204);
    }
    async removeConfig() {
        const response = await utils_1.invoke(this.swaggerClient.apis.Gateway.GatewayRestRemoveConfig({}));
        utils_1.checkStatus(response, 204);
    }
    async getConfig() {
        const response = await utils_1.invoke(this.swaggerClient.apis.Gateway.GatewayRestGetConfig({}));
        return utils_1.getResponseBody(response);
    }
}
exports.GatewayClient = GatewayClient;
//# sourceMappingURL=sdk-gateway.js.map