'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
const middleware_1 = require("./middleware");
exports.circuitBreakerConfigValidatorSchema = Joi.object().keys({
    maxFailures: Joi.number(),
    onClose: middleware_1.middlewareConfigValidatorSchema,
    onOpen: middleware_1.middlewareConfigValidatorSchema,
    onRejected: middleware_1.middlewareConfigValidatorSchema,
    rejectMessage: Joi.string(),
    rejectStatusCode: Joi.number(),
    resetTimeout: Joi.alternatives([Joi.string(), Joi.number().positive()]),
    timeWindow: Joi.alternatives([Joi.string(), Joi.number().positive()]),
    timeout: Joi.alternatives([Joi.string(), Joi.number().positive()]),
    timeoutMessage: Joi.string(),
    timeoutStatusCode: Joi.number()
});
exports.apiCircuitBreakerConfigValidatorSchema = exports.circuitBreakerConfigValidatorSchema.keys({
    group: Joi.alternatives([Joi.array().items(Joi.string()), Joi.string()]),
    use: Joi.string()
});
//# sourceMappingURL=circuit-breaker.js.map