'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
const httpConfigSchema = Joi.object().keys({
    listenPort: Joi.alternatives([Joi.number().positive(), Joi.string()]).required(),
});
const httpsConfigSchema = Joi.object().keys({
    certificate: Joi.string().required(),
    certificateAuthority: Joi.string(),
    ciphers: Joi.array().items(Joi.string()),
    honorCipherOrder: Joi.boolean(),
    listenPort: Joi.alternatives([Joi.number().positive(), Joi.string()]).required(),
    privateKey: Joi.string().required()
}).unknown(true);
exports.protocolConfigSchema = Joi.object().keys({
    http: httpConfigSchema,
    https: httpsConfigSchema
}).min(1);
//# sourceMappingURL=protocol.js.map