'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
const middleware_1 = require("./middleware");
const routerConfigValidatorSchema = Joi.object().keys({
    middleware: middleware_1.middlewareConfigValidatorSchema,
    serviceDiscovery: middleware_1.middlewareConfigValidatorSchema,
    ssl: Joi.boolean()
}).or('middleware', 'serviceDiscovery');
const targetSchema = Joi.object().keys({
    allow: Joi.alternatives([Joi.array().items(Joi.string()), Joi.string()]),
    deny: Joi.alternatives([Joi.array().items(Joi.string()), Joi.string()]),
    host: Joi.string().uri(),
    router: routerConfigValidatorSchema
}).xor('host', 'router');
const httpAgentSchema = Joi.object().keys({
    freeSocketKeepAliveTimeout: Joi.alternatives([Joi.string(), Joi.number().positive()]),
    keepAlive: Joi.boolean(),
    keepAliveTime: Joi.alternatives([Joi.string(), Joi.number().positive()]),
    maxFreeSockets: Joi.number().positive(),
    maxSockets: Joi.number().positive(),
    timeout: Joi.alternatives([Joi.string(), Joi.number().positive()])
});
exports.proxyValidatorSchema = Joi.object().keys({
    httpAgent: httpAgentSchema,
    limit: Joi.string(),
    preserveHostHdr: Joi.boolean(),
    supressViaHeader: Joi.boolean(),
    target: targetSchema.required(),
    timeout: Joi.alternatives([Joi.string(), Joi.number().positive()])
});
//# sourceMappingURL=proxy.js.map