'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
const errors_1 = require("./errors");
exports.userValidatorSchema = Joi.object().keys({
    email: Joi.string().email(),
    login: Joi.string().required(),
    name: Joi.string().required(),
    password: Joi.string(),
    roles: Joi.array().items(Joi.string()).unique()
});
exports.usersConfigValidatorSchema = Joi.object().keys({
    jwtSecret: Joi.string().required()
});
function validateUser(user) {
    return new Promise((resolve, reject) => {
        Joi.validate(user, exports.userValidatorSchema, (err, value) => {
            if (err) {
                reject(new errors_1.ValidationError(err));
            }
            else {
                resolve(value);
            }
        });
    });
}
exports.validateUser = validateUser;
//# sourceMappingURL=users.js.map