import { EventEmitter } from 'events';
import { DatabaseConfig } from './config/database';
import { GatewayConfig } from './config/gateway';
export declare class Configuration extends EventEmitter {
    static gatewayConfigFile: string;
    static resetBeforeStart: boolean;
    static instances: number;
    private config;
    private isLoaded;
    constructor();
    load(): Promise<void>;
    reload(): Promise<void>;
    readonly gateway: GatewayConfig;
    readonly rootPath: string;
    readonly middlewarePath: string;
    readonly database: DatabaseConfig;
    readonly loaded: boolean;
    private loadGatewayConfig;
    private ensureLoaded;
    private loadContainerConfigurations;
    private loadDatabaseConfig;
    private getConfigFromDB;
    private loadConfigObject;
    private removeExtension;
    private loadServerConfig;
    private loadDefaultServerConfig;
    private askRedisOptions;
    private createRedisConfiguration;
    private loadDefaultGatewayConfig;
    /**
     * This function cast all array properties inside server configuration to array.
     * It is used to allow user to configure array properties as a single item too.
     * @param server Server configuration
     */
    private castArrays;
}
