import * as express from 'express';
import { ApiConfig } from '../config/api';
import { ApiCorsConfig } from '../config/cors';
import { MiddlewareConfig } from '../config/middleware';
export declare class ApiPileline {
    private config;
    private logger;
    private apiProxy;
    private apiErrorHandler;
    private apiRateLimit;
    private apiCors;
    private apiCircuitBreaker;
    private apiCache;
    private apiAuth;
    private apiFilter;
    private requestLogger;
    private apiRoutes;
    private installedApis;
    readonly apis: Array<ApiConfig>;
    getApiConfig(apiId: string): ApiConfig;
    clearRoutes(): void;
    loadApi(api: ApiConfig, server: express.Application): Promise<void>;
    circuitChanged(id: string, state: string): void;
    loadApis(configs: Array<ApiConfig>, server: express.Application): Promise<void>;
    buildGatewayFilters(apiRouter: express.Router, filters: Array<MiddlewareConfig>): void;
    configureCors(config: ApiCorsConfig): express.RequestHandler;
    private removeOldAPIs;
    private loadValidApi;
    private configureDefaultCors;
    private configureLogMiddleware;
    private configureBodyParser;
    private maybeParseRawBody;
}
