'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const passport_http_1 = require("passport-http");
const typescript_ioc_1 = require("typescript-ioc");
const authentication_1 = require("../../../config/authentication");
const middleware_loader_1 = require("../../../utils/middleware-loader");
module.exports = function (authConfig) {
    authentication_1.validateBasicAuthConfig(authConfig);
    const middlewareLoader = typescript_ioc_1.Container.get(middleware_loader_1.MiddlewareLoader);
    const verifyFunction = middlewareLoader.loadMiddleware('authentication/verify', authConfig.verify);
    return new passport_http_1.BasicStrategy(verifyFunction);
};
module.exports.factory = true;
//# sourceMappingURL=basic.js.map