'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const passport_local_1 = require("passport-local");
const typescript_ioc_1 = require("typescript-ioc");
const authentication_1 = require("../../../config/authentication");
const middleware_loader_1 = require("../../../utils/middleware-loader");
module.exports = function (authConfig) {
    authentication_1.validateLocalAuthConfig(authConfig);
    const opts = _.omit(authConfig, 'verify');
    opts.session = false;
    const middlewareLoader = typescript_ioc_1.Container.get(middleware_loader_1.MiddlewareLoader);
    const verifyFunction = middlewareLoader.loadMiddleware('authentication/verify', authConfig.verify);
    return new passport_local_1.Strategy(opts, verifyFunction);
};
module.exports.factory = true;
//# sourceMappingURL=local.js.map