import * as redis from 'ioredis';
import { CacheEntry, CacheStore, StoreCallback } from './cache-store';
export interface Options {
    maxAge?: number;
    prefix?: string;
    client: redis.Redis;
}
export declare class RedisStore implements CacheStore<CacheEntry> {
    options: Options;
    constructor(options: Options);
    set(key: string, value: CacheEntry, maxAge?: number): void;
    get(key: string, callback: StoreCallback<CacheEntry>): void;
    del(key: string): void;
}
