import { StateHandler } from './express-circuit-breaker';
export declare class CircuitBreakerKeys {
    static CIRCUIT_BREAKER_FAILURES: string;
    static CIRCUIT_BREAKER_STATE: string;
}
export declare class RedisStateHandler implements StateHandler {
    halfOpenCallPending: boolean;
    private logger;
    private database;
    private id;
    private state;
    private resetTimeout;
    private timeWindow;
    private timerHalfOpen;
    constructor(id: string, resetTimeout: number, timeWindow?: number);
    initialState(): void;
    isOpen(): boolean;
    isHalfOpen(): boolean;
    isClosed(): boolean;
    forceOpen(): boolean;
    forceClose(): boolean;
    forceHalfOpen(): boolean;
    incrementFailures(): Promise<number>;
    onStateChanged(state: string): void;
    destroy(): void;
    private getRedisFailuresKey;
    private getRedisStateKey;
    private openState;
    private closeState;
    private notifyCircuitOpen;
    private notifyCircuitClose;
}
