'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_rest_1 = require("typescript-rest");
class UnauthorizedError extends typescript_rest_1.Errors.UnauthorizedError {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, UnauthorizedError.prototype);
    }
}
exports.UnauthorizedError = UnauthorizedError;
class NotFoundError extends typescript_rest_1.Errors.NotFoundError {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, NotFoundError.prototype);
    }
}
exports.NotFoundError = NotFoundError;
class UnavailableError extends Error {
    constructor(message) {
        super(message);
        this.statusCode = 503;
        Object.setPrototypeOf(this, UnavailableError.prototype);
    }
}
exports.UnavailableError = UnavailableError;
class ProxyError extends typescript_rest_1.HttpError {
    constructor(message, statusCode) {
        super('gatewayError', statusCode, message);
        Object.setPrototypeOf(this, ProxyError.prototype);
    }
}
exports.ProxyError = ProxyError;
//# sourceMappingURL=errors.js.map