import * as express from 'express';
import { ApiConfig } from '../../config/api';
import { ApiPipelineConfig } from '../../config/gateway';
export interface ResponseInterceptors {
    middelware: Function;
    validators: Array<Function>;
}
export declare class ProxyInterceptor {
    private middlewareLoader;
    private logger;
    buildRequestInterceptors(apiRouter: express.Router, api: ApiConfig, pipelineConfig: ApiPipelineConfig): void;
    buildResponseInterceptors(api: ApiConfig, pipelineConfig: ApiPipelineConfig): ResponseInterceptors;
    hasRequestInterceptor(api: ApiConfig): boolean;
    hasResponseInterceptor(api: ApiConfig): boolean;
    private resolveRequestInterceptorReferences;
    private resolveResponseInterceptorReferences;
    private createRequestInterceptors;
    private createResponseInterceptors;
}
