'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const jsonata_1 = require("../../../config/jsonata");
const jsonata = require('jsonata');
module.exports = function (config) {
    jsonata_1.validateJsonAtaExpression(config);
    const expression = jsonata(config.expression);
    return (req) => {
        const result = {};
        try {
            let body = req.body;
            if (typeof body === 'string' || Buffer.isBuffer(req.body)) {
                body = JSON.parse(body.toString());
            }
            result.body = expression.evaluate(body);
        }
        catch (e) {
            result.body = '';
        }
        return result;
    };
};
module.exports.factory = true;
//# sourceMappingURL=requestBodyTransformer.js.map