'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_ioc_1 = require("typescript-ioc");
const configuration_1 = require("../../configuration");
const middleware_loader_1 = require("../../utils/middleware-loader");
const path_1 = require("../../utils/path");
let RequestLogger = class RequestLogger {
    initialize() {
        this.requestLogHandler = this.middlewareLoader.loadMiddleware('request/logger', this.getRequestLogMiddleware());
    }
    isRequestLogEnabled(api) {
        return (this.isGatewayRequestLogEnabled() && !api.disableAnalytics);
    }
    isGatewayRequestLogEnabled() {
        return this.config.gateway.analytics && this.config.gateway.analytics.enabled;
    }
    getRequestLog(req) {
        return req.requestLog;
    }
    initRequestLog(req, api) {
        req.requestLog = {
            apiId: api.id,
            ip: req.ip,
            method: req.method,
            path: path_1.normalizePath(req.path),
            timestamp: new Date().getTime()
        };
        return req.requestLog;
    }
    registerOccurrence(requestLog) {
        this.requestLogHandler(requestLog);
    }
    getRequestLogMiddleware() {
        if (this.config.gateway.analytics && this.config.gateway.analytics.logger) {
            return this.config.gateway.analytics.logger;
        }
        return {
            name: 'redis',
            options: {
                maxEntries: 10000
            }
        };
    }
};
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", configuration_1.Configuration)
], RequestLogger.prototype, "config", void 0);
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", middleware_loader_1.MiddlewareLoader)
], RequestLogger.prototype, "middlewareLoader", void 0);
RequestLogger = __decorate([
    typescript_ioc_1.AutoWired,
    typescript_ioc_1.Singleton
], RequestLogger);
exports.RequestLogger = RequestLogger;
//# sourceMappingURL=request.js.map