import * as express from 'express';
import { UserData } from '../../config/users';
import { UserService } from '../users';
export declare class RedisUserService implements UserService {
    static USERS_PREFIX: string;
    private config;
    private database;
    private middlewareLoader;
    list(): Promise<Array<UserData>>;
    get(login: string): Promise<UserData>;
    create(user: UserData): Promise<void>;
    changePassword(login: string, password: string): Promise<void>;
    update(user: UserData): Promise<void>;
    remove(login: string): Promise<void>;
    generateToken(login: string, password: string): Promise<string>;
    getAuthMiddleware(): express.RequestHandler;
}
