'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
function checkEnvVariable(value, asNumber) {
    if (_.isNumber(value)) {
        return value;
    }
    if (_.startsWith(value, '{') && _.endsWith(value, '}')) {
        const envVariable = value.substring(1, value.length - 1);
        if (asNumber) {
            return Number(process.env[envVariable]);
        }
        return process.env[envVariable];
    }
    if (asNumber) {
        return Number(value);
    }
    return value;
}
exports.checkEnvVariable = checkEnvVariable;
//# sourceMappingURL=env.js.map