import { EventEmitter } from 'events';
export interface HealthCheckOptions {
    checkInterval?: string | number;
    failCount?: number;
    servers: Array<string>;
    waitTimeout?: string | number;
}
export interface CheckServer {
    down: boolean;
    failCount: number;
    lastStatus: string;
}
export declare class HealthCheck extends EventEmitter {
    private logger;
    private checks;
    private previousChecks;
    private options;
    private interval;
    private checking;
    constructor(options: HealthCheckOptions);
    start(): void;
    stop(): void;
    isDown(serverUrl: string): any;
    status(): any;
    private check;
    private checkServer;
}
